#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Dfinitions de nouveaux types. */
typedef enum sens {arriere, avant} Sens;
typedef struct cellule
{
   char   *chaine;
   struct  cellule *ptr_precedent;
   struct  cellule *ptr_suivant;
} CEL;

void  liste ( CEL *p, Sens sens );
void  libere( CEL *p );
CEL  *debut = NULL;

int main()
{
  CEL  *ptr_courant = NULL;
  char  chaine[40];

  /*
   * Boucle de lecture sur l'entre standard
   * avec "--> " comme prompt.
   */
  fputs( "--> ", stdout );
  gets( chaine );
  while( ! feof( stdin ) )
  {
    /*
     * Si "la" est la chane entre,
     * on liste les chanes dj saisies.
     */
    if( ! strcmp( chaine, "la" ) )
      liste( debut, avant );
    /*
     * Si "li" est la chane entre,
     * on liste les chanes dj saisies
     * dans l'ordre inverse.
     */
    else if( ! strcmp( chaine, "li" ) )
      liste( ptr_courant, arriere );
    else
    {
      // C'est la 1re chane.
      if( debut == NULL )
      {
        debut = malloc( sizeof(CEL) );
        debut->ptr_precedent = NULL;
        ptr_courant = debut;
      }
      else
      {
        // C'est une chane diffrente de la 1re.
        ptr_courant->ptr_suivant = malloc( sizeof(CEL) );
        ptr_courant->ptr_suivant->ptr_precedent = ptr_courant;
        ptr_courant = ptr_courant->ptr_suivant;
      }
      // On valorise le nouvel lment de la liste.
      ptr_courant->chaine = strdup( chaine );
      ptr_courant->ptr_suivant = NULL;
    }
    fputs( "--> ", stdout );
    gets( chaine );
  }
  // On libre la liste.
  if( debut != NULL )
    libere( debut );

  printf( "\n\nFin EXO14.\n" );

  return 0;
}

// Fonction rcursive d'affichage de la liste.
void liste( CEL *p, Sens sens )
{
  if( debut == NULL )
  {
    printf( "Dsol! la liste est vide.\n\n" );
    return;
  }
  if ( p != NULL )
  {
    printf( "\t%s\n", p->chaine );
    liste( sens == avant ?
              p->ptr_suivant : p->ptr_precedent, sens );
  }

  return;
}

// Fonction librant la mmoire occupe par la liste.
void libere( CEL *p )
{
  if ( p->ptr_suivant != NULL )
    libere( p->ptr_suivant );

  free( p->chaine );
  free( p );

  return;
}
